/*********************************************************************************
* Copyright (c) 2013 David D. Marshall <ddmarsha@calpoly.edu>
*
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*    David D. Marshall - initial code and implementation
********************************************************************************/

#ifndef eli_geom_curve_hpp
#define eli_geom_curve_hpp

// include types of curves
#include "eli/geom/curve/bezier.hpp"
#include "eli/geom/curve/explicit_bezier.hpp"
#include "eli/geom/curve/piecewise.hpp"
#include "eli/geom/curve/pseudo.hpp"

// include helpers
#include "eli/geom/curve/piecewise_creator.hpp"
#include "eli/geom/curve/fit_container.hpp"
#include "eli/geom/curve/length.hpp"
#include "eli/geom/curve/curvature.hpp"
#include "eli/geom/curve/torsion.hpp"
#include "eli/geom/curve/equivalent_curves.hpp"
#include "eli/geom/curve/pseudo.hpp"

// include utilities
#include "eli/geom/curve/utility.hpp"

#endif
